/**
 *　HTMLメール送信（添付ファイル付き）
 *  （注）@ViewScopedでは<f:inputFile>が動作しなかった。
 * 　　　その場合、@Namedを@ManagedBeanに変えると動作する。
*/
package beans;
import java.io.File;
import javax.servlet.http.Part;
import java.io.IOException;
import java.io.InputStream;
import java.nio.file.Files;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.enterprise.context.RequestScoped;
import javax.inject.Named;

import javax.faces.context.FacesContext;
import javax.servlet.ServletContext;

@Named
@RequestScoped
public class Bb {

    private Part file;      // アップロードされたファイル

    public void upload(){
        try {
            InputStream in = file.getInputStream();
            String filepath = getRealPath("resources/files");// 絶対パスに変換
            String filename = file.getSubmittedFileName();
            Files.copy(in, new File(filepath ,filename).toPath()); // ファイル保管
        } catch (IOException ex) {
            Logger.getLogger(Bb.class.getName()).log(Level.SEVERE, ex.toString());
        }
    }
    
    /**
     * アプリケーションルートからの相対パスを絶対パスに変換する
     * @param path  アプリケーションルートのリソースからの相対パス（ex. /resources/～）
     * @return      絶対パス
     */
    public String getRealPath(String path) {
        ServletContext ctx = (ServletContext) FacesContext.getCurrentInstance().getExternalContext().getContext();
        return ctx.getRealPath(path);
    }    
    
    // セッターとゲッター
    public Part getFile() {
        return file;
    }
    public void setFile(Part file) {
        this.file = file;
    }
    
}
